
UsePNGImageDecoder()

; ################################ Dokumentation / Kommentare #########################
; 
; Todo:
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 

; #################################################### Structures ################################################

Structure Object_Range
  Offset.q
  Size.q
  
  Metadata.a
  Type_State.i
EndStructure

Structure Object
  Window_ID.i
  Canvas.i
  ScrollBar.i [10]
  
  *Hilbert.Object_Hilbert
  
  Name.s
  Short_Name.s
  
  Width.i
  Height.i
  
  Editor_Width.i
  Editor_Height.i
  
  Font_Width.i
  Font_Height.i
  
  View_O_X.i [10]
  View_O_Y.i [10]
  View_Offset_Digits.i
  View_Scroll_Pos.q
  View_Scroll_Range.q
  View_Scroll_Page.q
  View_Scroll_Divider.q
  
  Cursor.q [2]    ; Position of the cursor(s)
  Cursor_Nibble.i ; Nibble offset of the first cursor
  Mark_Mode.i     ; 
  Write_Mode.i
  
  List Range.Object_Range()
  
  Timer_Reload_Range.i
  Timer_Reload_Data.i
  
  ; ####
  
  Total_Lines.q   ; Total Lines of the Object
  View_Lines.q    ; Lines in the Viewport
  Rows.q          ; Amount of Bytes / Line
  
  ; ####
  
  *Data_Source.Data_Source
  
  *Data           ; Data in the viewport
  *Metadata       ; Metadata for the viewport
  Data_Size.q     ; Size of the data in the viewport
  Metadata_Size.q ; Size of the metadata in the viewport
  Data_Offset.q   ; Offset of the data
  
  Total_Size.q    ; Total Size of the Data
  
  ; ####
  
  *Last_Search_Keyword
  Last_Search_Keyword_Length.i
EndStructure

; ########################################## Variablen ################################

#Version = 610

Structure Main
  Version.i
  
  Font_ID.i
  Font_Width.i
  Font_Height.i
  
  Quit.i                  ; Programm beenden
EndStructure
Global Main.Main

Structure Window_Main
  ID.i
  Menu_ID.i
  ToolBar_ID.i
  StatusBar_ID.i
  MDI.i
  Panel.i
  ; ####
  MDI_Height.i
  MDI_Widht.i
  Panel_Height.i          ; Hhe des Panels
  Menu_Height.i           ; Hhe des Mens
  ToolBar_Height.i        ; Hhe der ToolBar
  StatusBar_Height.i      ; Hhe der StatusBar
EndStructure
Global Window_Main.Window_Main

Enumeration 1
  #Menu_Dummy
  
  #Menu_New
  #Menu_Save
  #Menu_SaveAs
  #Menu_Close
  #Menu_Exit
  
  #Menu_Open_File
  #Menu_Open_Process
  #Menu_Open_Clipboard
  #Menu_Open_Random
  
  #Menu_Search
  #Menu_Search_Continue
  
  #Menu_View_Resize
  
  #Menu_Visualisation_Hilbert
  
  #Menu_Help
  #Menu_About
  
  #Menu_MDI_Windows_Start
EndEnumeration


#Object_Metadata_Readable   = %00000001
#Object_Metadata_Writeable  = %00000010
#Object_Metadata_Executable = %00000100


#Object_Metadata_Changed    = %01000000
#Object_Metadata_Error      = %10000000

; ########################################## Ladekram ################################

Global Icon_New = LoadImage(#PB_Any, "Data\Icons\New.png")
Global Icon_Save = LoadImage(#PB_Any, "Data\Icons\Save.png")
Global Icon_SaveAs = LoadImage(#PB_Any, "Data\Icons\SaveAs.png")
Global Icon_Open_File = LoadImage(#PB_Any, "Data\Icons\Open_File.png")
Global Icon_Open_Process = LoadImage(#PB_Any, "Data\Icons\Open_Process.png")
Global Icon_Open_Clipboard = LoadImage(#PB_Any, "Data\Icons\Open_Clipboard.png")
Global Icon_Open_Random = LoadImage(#PB_Any, "Data\Icons\Open_Random.png")
Global Icon_Close = LoadImage(#PB_Any, "Data\Icons\Close.png")
Global Icon_Resize = LoadImage(#PB_Any, "Data\Icons\Resize.png")
Global Icon_Hilbert = LoadImage(#PB_Any, "Data\Icons\Hilbert.png")

Main\Font_ID = LoadFont(#PB_Any, "Courier New", 10)
Temp_Image = CreateImage(#PB_Any, 1, 1)
If StartDrawing(ImageOutput(Temp_Image))
  DrawingFont(FontID(Main\Font_ID))
  Main\Font_Width = TextWidth("0")
  Main\Font_Height = TextHeight("0")
  StopDrawing()
EndIf
FreeImage(Temp_Image)

; ########################################## Macros ##################################

Macro Int_Divide_RUP(A, B)
  (((A)+(B)-1) / (B))
EndMacro

; ########################################## Declares ################################

Declare Window_Main_Panel_Rebuild(Active_Window_ID.i)

; ########################################## Includes ################################

XIncludeFile "Includes\Memory.pbi"
XIncludeFile "Includes\Data_Source.pbi"
XIncludeFile "Includes\Object_Hilbert.pbi"
XIncludeFile "Includes\Object.pbi"
XIncludeFile "Includes\About.pbi"
XIncludeFile "Includes\Process.pbi"
XIncludeFile "Includes\Object_Find.pbi"

; ########################################## Proceduren ################################

Procedure Open_Window_Main(Width, Height)
  
  Window_Main\ID = OpenWindow(#PB_Any, 0, 0, Width, Height, "D3hex V"+StrF(Main\Version*0.001,2), #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)
  
  If Not Window_Main\ID
    ProcedureReturn 0
  EndIf
  
  SmartWindowRefresh(Window_Main\ID, 1)
  
  Window_Main\Menu_ID = CreateImageMenu(#PB_Any, WindowID(Window_Main\ID), #PB_Menu_ModernLook)
  If Not Window_Main\Menu_ID
    MessageRequester("D3hex", "Men konnte nicht erstellt werden.")
    CloseWindow(Window_Main\ID)
    ProcedureReturn 0
  EndIf
  
  MenuTitle("File")
  MenuItem(#Menu_New, "New", ImageID(Icon_New))
  MenuItem(#Menu_Save, "Save", ImageID(Icon_Save))
  MenuItem(#Menu_SaveAs, "Save as...", ImageID(Icon_SaveAs))
  MenuItem(#Menu_Close, "Close", ImageID(Icon_Close))
  MenuBar()
  MenuItem(#Menu_Open_File, "Open File...", ImageID(Icon_Open_File))
  MenuItem(#Menu_Open_Process, "Open Process...", ImageID(Icon_Open_Process))
  MenuItem(#Menu_Open_Clipboard, "Open Clipboard", ImageID(Icon_Open_Clipboard))
  MenuItem(#Menu_Open_Random, "Open Random", ImageID(Icon_Open_Random))
  MenuBar()
  MenuItem(#Menu_Exit, "Exit")
  
  MenuTitle("Edit")
  
  MenuTitle("Search")
  MenuItem(#Menu_Search, "Search...")
  MenuItem(#Menu_Search_Continue, "Continue")
  
  MenuTitle("View")
  MenuItem(#Menu_View_Resize, "Resize", ImageID(Icon_Resize))
  
  MenuTitle("Visualisation")
  MenuItem(#Menu_Visualisation_Hilbert, "Hilbert View", ImageID(Icon_Hilbert))
  
  MenuTitle("Windows")
  ;MenuItem(#Menu_Dummy, "Nebeneinander")
  ;MenuItem(#Menu_Dummy, "berlappend")
  ;MenuItem(#Menu_Dummy, "Windows...")
  
  MenuTitle("?")
  MenuItem(#Menu_Help, "Help")
  MenuItem(#Menu_About, "About")
  
  ; ######################### Shortcuts
  
  AddKeyboardShortcut(Window_Main\ID, #PB_Shortcut_Control | #PB_Shortcut_F, #Menu_Search)
  AddKeyboardShortcut(Window_Main\ID, #PB_Shortcut_F3, #Menu_Search_Continue)
  
  ; ######################### Toolbar
  
  Window_Main\ToolBar_ID = CreateToolBar(#PB_Any, WindowID(Window_Main\ID))
  If Not Window_Main\ToolBar_ID
    MessageRequester("D3hex", "ToolBar konnte nicht erstellt werden.")
    CloseWindow(Window_Main\ID)
    ProcedureReturn 0
  EndIf
  
  ToolBarImageButton(#Menu_New, ImageID(Icon_New))
  ToolBarImageButton(#Menu_Save, ImageID(Icon_Save))
  ToolBarImageButton(#Menu_SaveAs, ImageID(Icon_SaveAs))
  ToolBarImageButton(#Menu_Close, ImageID(Icon_Close))
  ToolBarSeparator()
  ToolBarImageButton(#Menu_Open_File, ImageID(Icon_Open_File))
  ToolBarImageButton(#Menu_Open_Process, ImageID(Icon_Open_Process))
  ToolBarImageButton(#Menu_Open_Clipboard, ImageID(Icon_Open_Clipboard))
  ToolBarImageButton(#Menu_Open_Random, ImageID(Icon_Open_Random))
  ToolBarSeparator()
  ToolBarImageButton(#Menu_View_Resize, ImageID(Icon_Resize))
  ToolBarSeparator()
  ToolBarImageButton(#Menu_Visualisation_Hilbert, ImageID(Icon_Hilbert))
  
  ; ######################### Statusbar
  
  Window_Main\StatusBar_ID = CreateStatusBar(#PB_Any, WindowID(Window_Main\ID))
  If Not Window_Main\StatusBar_ID
    MessageRequester("D3hex", "Statusbar konnte nicht erstellt werden.")
    CloseWindow(Window_Main\ID)
    ProcedureReturn 0
  EndIf
  
  AddStatusBarField(150)
  AddStatusBarField(250)
  AddStatusBarField(150)
  
  ; ######################### Gre
  
  Window_Main\Menu_Height = MenuHeight()
  Window_Main\ToolBar_Height =  ToolBarHeight(Window_Main\ToolBar_ID)
  Window_Main\Panel_Height = 20
  Window_Main\StatusBar_Height =  StatusBarHeight(Window_Main\StatusBar_ID)
  
  Window_Main\MDI_Widht = Width
  Window_Main\MDI_Height = Height - Window_Main\Menu_Height - Window_Main\ToolBar_Height - Window_Main\Panel_Height - Window_Main\StatusBar_Height
  
  ; ################# Gadgets
  
  If UseGadgetList(WindowID(Window_Main\ID))
    Window_Main\MDI = MDIGadget(#PB_Any, 0, Window_Main\ToolBar_Height + Window_Main\Panel_Height, Window_Main\MDI_Widht, Window_Main\MDI_Height, 5, #Menu_MDI_Windows_Start)
    
    Window_Main\Panel = PanelGadget(#PB_Any, 0, Window_Main\ToolBar_Height, Window_Main\MDI_Widht, Window_Main\Panel_Height)
  EndIf
EndProcedure

Procedure Window_Main_Title_Set()
  SetWindowTitle(Window_Main\ID, "D3hex V"+StrF(Main\Version*0.001,2))
EndProcedure

Procedure Window_Main_Panel_Rebuild(Active_Window_ID.i)
  ClearGadgetItems(Window_Main\Panel)
  
  i = 0
  ForEach Object()
    OpenGadgetList(Window_Main\Panel)
    AddGadgetItem(Window_Main\Panel, i, Object()\Short_Name)
    CloseGadgetList()
    SetGadgetItemData(Window_Main\Panel, i, Object()\Window_ID)
    i + 1
    
    If Object()\Hilbert
      OpenGadgetList(Window_Main\Panel)
      AddGadgetItem(Window_Main\Panel, i, "H: "+Object()\Short_Name)
      CloseGadgetList()
      SetGadgetItemData(Window_Main\Panel, i, Object()\Hilbert\Window_ID)
      i + 1
    EndIf
  Next
  
  If Not Active_Window_ID
    Active_Window_ID = GetGadgetState(Window_Main\MDI)
  EndIf
  
  For i = 0 To CountGadgetItems(Window_Main\Panel) - 1
    If GetGadgetItemData(Window_Main\Panel, i) = Active_Window_ID
      SetGadgetState(Window_Main\Panel, i)
      Break
    EndIf
  Next
EndProcedure

; ########################################## Initkram ################################

Main\Version = #Version

Open_Window_Main(800, 600)

; ########################################## Hauptschleife ################################

Repeat
  
  Repeat
    Event = WindowEvent()
    Event_Window = EventWindow()
    Event_Type = EventType()
    
    Select Event_Window
      Case Window_Main\ID
        
        Select Event
          Case #PB_Event_SizeWindow ; ##############
            Window_Main\MDI_Widht = WindowWidth(Window_Main\ID)
            Window_Main\MDI_Height = WindowHeight(Window_Main\ID) - Window_Main\Menu_Height - Window_Main\ToolBar_Height - Window_Main\Panel_Height - Window_Main\StatusBar_Height
            ResizeGadget(Window_Main\Panel, #PB_Ignore, #PB_Ignore, Window_Main\MDI_Widht, #PB_Ignore)
            ResizeGadget(Window_Main\MDI, #PB_Ignore, #PB_Ignore, Window_Main\MDI_Widht, Window_Main\MDI_Height)
          
          Case #PB_Event_Menu ; ####################
            Select EventMenu()
              Case #Menu_New
                Filename.s = SaveFileRequester("Create File", "", "All Files | *.*", 0)
                If Filename
                  Object_Add(Filename, GetFilePart(Filename), Data_Source_Create(#Data_Source_File, Filename, 1))
                EndIf
              
              Case #Menu_Open_File
                Filename.s = OpenFileRequester("Open File", "", "All Files | *.*", 0)
                If Filename
                  Object_Add(Filename, GetFilePart(Filename), Data_Source_Create(#Data_Source_File, Filename))
                EndIf
                
              Case #Menu_Open_Process
                Window_Process(1)
                
              Case #Menu_Open_Clipboard
                Object_Add("Clipboard", "CLP", Data_Source_Create(#Data_Source_Clipboard, ""))
                
              Case #Menu_Open_Random
                Object_Add("Random", "RND", Data_Source_Create(#Data_Source_Random, ""))
                
              Case #Menu_Search
                Window_Object_Find(1)
                
              Case #Menu_Search_Continue
                Object_Find_Continue()
                
              Case #Menu_View_Resize
                ForEach Object()
                  If Object()\Window_ID = GetGadgetState(window_Main\MDI)
                    Object()\Rows = Val(InputRequester("Resize Hex-View", "Rows:", Str(Object()\Rows)))
                    If Object()\Rows < 1 : Object()\Rows = 1 : EndIf
                    Object_View_Redo(Object(), -1, -1, -1, -1, -1, -1, 1)
                    Break
                  EndIf
                Next
                
              Case #Menu_Visualisation_Hilbert
                ForEach Object()
                  If Object()\Window_ID = GetGadgetState(window_Main\MDI)
                    If Not Object()\Hilbert
                      Object()\Hilbert = Object_Hilbert_Create(Object())
                    EndIf
                    If Object()\Hilbert
                      SetGadgetState(Window_Main\MDI, Object()\Hilbert\Window_ID)
                      Window_Main_Panel_Rebuild(Object()\Hilbert\Window_ID)
                    EndIf
                    Break
                  EndIf
                Next
                
              Case #Menu_About
                Window_About(1)
                
              Case #Menu_Exit
                Main\Quit = 1
                
            EndSelect
          
          Case #PB_Event_Gadget ; ##################
            Select EventGadget()
              Case Window_Main\Panel
                SetGadgetState(window_Main\MDI, GetGadgetItemData(Window_Main\Panel, GetGadgetState(Window_Main\Panel)))
                
            EndSelect
            
          Case #PB_Event_CloseWindow
            Main\Quit = 1
            
          Case 0
            Break
            
        EndSelect
        
      Default
        If Event
          ForEach Object()
            If Object()\Window_ID = Event_Window
              Object_Event(Object(), Event, Event_Type)
            EndIf
          Next
          ForEach Object()
            If Object()\Hilbert And Object()\Hilbert\Window_ID = Event_Window
              Object_Hilbert_Event(Object()\Hilbert, Event, Event_Type)
            EndIf
          Next
          If Event_Window = Window_About\ID : About_Event(Event, Event_Type) : EndIf
          If Event_Window = Window_Process\ID : Process_Event(Event, Event_Type) : EndIf
          If Event_Window = Window_Object_Find\ID : Object_Find_Event(Event, Event_Type) : EndIf
        Else
          Break
        EndIf
        
    EndSelect
  ForEver
  
  ; ##################
  
  ForEach Object()
    If Object()\Hilbert
      Object_Hilbert_Main(Object()\Hilbert)
    EndIf
  Next
  
  ForEach Object()
    If Object()\Window_ID = GetGadgetState(Window_Main\MDI)
      If Object()\Timer_Reload_Range < ElapsedMilliseconds()
        Object()\Timer_Reload_Range = ElapsedMilliseconds() + 1000
        Data_Source_Get_Ranges(Object()\Data_Source, Object())
        Object_View_Redo(Object(), -1, -1, -1, -1, -1, -1, 1)
      EndIf
      If Object()\Timer_Reload_Data < ElapsedMilliseconds()
        Object()\Timer_Reload_Data = ElapsedMilliseconds() + 500
        Object_Data_Update(Object(), 0, -1, 1)
        Object_View_Redo(Object(), -1, -1, -1, -1, -1, -1, 1)
      EndIf
      Break
    EndIf
  Next
  
  ; ###################
  
  Delay(10)
  
Until Main\Quit = 1

; ########################################## Beenden ################################
; IDE Options = PureBasic 4.60 RC 2 (Windows - x64)
; CursorPosition = 238
; FirstLine = 203
; Folding = -
; EnableXP
; Executable = D3hex.x64.exe
; DisableDebugger
; Compiler = PureBasic 4.60 Beta 1 (Windows - x86)
; EnableCompileCount = 1055
; EnableBuildCount = 3