; #################################################### Initstuff #################################################

; #################################################### Includes ##################################################

; #################################################### Prototypes ################################################

; #################################################### Variables #################################################

Global NewList Object.Object()

; #################################################### Constants #################################################

Enumeration
  #Object_Mark_Mode_None
  #Object_Mark_Mode_Hex
  #Object_Mark_Mode_Ascii
  
  #Object_Mark_Mode_Hex_Write
  #Object_Mark_Mode_Ascii_Write
EndEnumeration

Enumeration
  #Object_Write_Mode_Overwrite
  #Object_Write_Mode_Insert
EndEnumeration

; #################################################### Declares ##################################################

; #################################################### Macros ####################################################

; #################################################### Procedures ################################################

Procedure Object_Redraw_Filter_Blink(x, y, SourceColor, TargetColor)
  If (x+y) & 1
    ProcedureReturn ~TargetColor
  Else
    ProcedureReturn TargetColor
  EndIf
EndProcedure

Procedure Object_Redraw_Filter_Reverse(x, y, SourceColor, TargetColor)
  ProcedureReturn ~TargetColor
EndProcedure

Procedure Object_Redraw(*Object.Object)
  Protected *Pointer.Ascii
  Protected *Pointer_2.Ascii
  
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  If Not StartDrawing(CanvasOutput(*Object\Canvas))
    ProcedureReturn #False
  EndIf
  
  ;Box(0, 0, *Object\View_O_X[5]+10, *Object\Editor_Height, RGB(255,255,255))
  Box(0, 0, *Object\Editor_Width, *Object\Editor_Height, RGB(255,255,255))
  
  DrawingMode(#PB_2DDrawing_Outlined)
  DrawingFont(FontID(Main\Font_ID))
  
  BackColor(RGB(255, 255, 255))
  FrontColor(RGB(0, 0, 255))
  
  DrawText(*Object\View_O_X[0], *Object\View_O_Y[0], "Offset(h)")
  For iy = 0 To *Object\View_Lines - 1
    DrawText(*Object\View_O_X[0], *Object\View_O_Y[2] + iy* *Object\Font_Height, RSet(Hex(*Object\Data_Offset + iy* *Object\Rows), *Object\View_Offset_Digits, "0"))
  Next
  For ix = 0 To *Object\Rows - 1
    DrawText(*Object\View_O_X[2] + ix* *Object\Font_Width*3, *Object\View_O_Y[0], RSet(Hex(ix), 2, "0"))
  Next
  
  BackColor(RGB(255, 255, 255))
  FrontColor(RGB(0, 0, 0))
  
  ix = 0
  iy = 0
  
  For i = 0 To *Object\Data_Size; - 1
    If *Object\Data_Offset + i < *Object\Total_Size
      If *Object\Data And *Object\Metadata
        *Pointer = *Object\Data + i
        *Pointer_2 = *Object\Metadata + i
        Byte.i = *Pointer\a
        Metadata.i = *Pointer_2\a
      Else
        Metadata.i = #Object_Metadata_Error
      EndIf
      
      Cursor_0.q = *Object\Cursor[0]
      Cursor_1.q = *Object\Cursor[1]
      If Cursor_0 > Cursor_1 : Swap Cursor_0, Cursor_1 : EndIf
      If Metadata & #Object_Metadata_Readable
        Text.s = RSet(Hex(Byte), 2, "0")+" "
      ElseIf Metadata & #Object_Metadata_Error
        Text.s = "XX "
      Else
        Text.s = "?? "
      EndIf
      If i + *Object\Data_Offset >= Cursor_0 And i + *Object\Data_Offset < Cursor_1
        DrawText(*Object\View_O_X[2] + ix*3, *Object\View_O_Y[2] + iy, Text, RGB(255, 255, 255), RGB(51, 153, 255))
      Else
        DrawText(*Object\View_O_X[2] + ix*3, *Object\View_O_Y[2] + iy, Text)
      EndIf
    EndIf
    If i + *Object\Data_Offset = *Object\Cursor[0]
      Select *Object\Mark_Mode
        Case #Object_Mark_Mode_Hex, #Object_Mark_Mode_Hex_Write
          DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_CustomFilter)
          CustomFilterCallback(@Object_Redraw_Filter_Reverse())
          Select *Object\Cursor_Nibble
            Case 1  : Box(*Object\View_O_X[2] + ix*3 + *Object\Font_Width, *Object\View_O_Y[2]+iy, 2, *Object\Font_Height)
            Case 0  : Box(*Object\View_O_X[2] + ix*3, *Object\View_O_Y[2]+iy, 2, *Object\Font_Height)
          EndSelect
          DrawingMode(#PB_2DDrawing_Outlined)
        Case #Object_Mark_Mode_Ascii, #Object_Mark_Mode_Ascii_Write
          DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_CustomFilter)
          CustomFilterCallback(@Object_Redraw_Filter_Blink())
          Select *Object\Cursor_Nibble
            Case 1  : Box(*Object\View_O_X[2] + ix*3 + *Object\Font_Width, *Object\View_O_Y[2]+iy, *Object\Font_Width, *Object\Font_Height)
            Case 0  : Box(*Object\View_O_X[2] + ix*3, *Object\View_O_Y[2]+iy, *Object\Font_Width, *Object\Font_Height)
          EndSelect
          DrawingMode(#PB_2DDrawing_Outlined)
      EndSelect
    EndIf
    If *Object\Data_Offset + i < *Object\Total_Size
      If Metadata & #Object_Metadata_Readable
        If Byte >= 32
          Char.s = Chr(Byte)
        Else
          Char.s = "."
        EndIf
      ElseIf Metadata & #Object_Metadata_Error
        Char.s = "X"
      Else
        Char.s = "?"
      EndIf
      If i + *Object\Data_Offset >= Cursor_0 And i + *Object\Data_Offset < Cursor_1
        DrawText(*Object\View_O_X[4] + ix, *Object\View_O_Y[2] + iy, Char, RGB(255, 255, 255), RGB(51, 153, 255))
      Else
        DrawText(*Object\View_O_X[4] + ix, *Object\View_O_Y[2] + iy, Char)
      EndIf
    EndIf
    If i + *Object\Data_Offset = *Object\Cursor[0]
      Select *Object\Mark_Mode
        Case #Object_Mark_Mode_Hex, #Object_Mark_Mode_Hex_Write
          DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_CustomFilter)
          CustomFilterCallback(@Object_Redraw_Filter_Blink())
          Box(*Object\View_O_X[4] + ix, *Object\View_O_Y[2]+iy, *Object\Font_Width, *Object\Font_Height)
          DrawingMode(#PB_2DDrawing_Outlined)
        Case #Object_Mark_Mode_Ascii, #Object_Mark_Mode_Ascii_Write
          DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_CustomFilter)
          CustomFilterCallback(@Object_Redraw_Filter_Reverse())
          Box(*Object\View_O_X[4] + ix, *Object\View_O_Y[2]+iy, 2, *Object\Font_Height)
          DrawingMode(#PB_2DDrawing_Outlined)
      EndSelect
    EndIf
    ix + *Object\Font_Width
    If ix = *Object\Font_Width * *Object\Rows
      ix = 0
      iy + *Object\Font_Height
    EndIf
  Next
  
  StopDrawing()
  
  If *Object\Window_ID = GetGadgetState(Window_Main\MDI)
    If *Object\Cursor[0] < *Object\Cursor[1]
      StatusBarText(Window_Main\StatusBar_ID, 0, "Offset: "+Hex(*Object\Cursor[0]))
    Else
      StatusBarText(Window_Main\StatusBar_ID, 0, "Offset: "+Hex(*Object\Cursor[1]))
    EndIf
    
    If *Object\Cursor[0] <> *Object\Cursor[1]
      If *Object\Cursor[0] < *Object\Cursor[1]
        StatusBarText(Window_Main\StatusBar_ID, 1, "Block: "+Hex(*Object\Cursor[0])+" - "+Hex(*Object\Cursor[1]-1))
        StatusBarText(Window_Main\StatusBar_ID, 2, "Length: "+Hex(*Object\Cursor[1]-*Object\Cursor[0]))
      Else
        StatusBarText(Window_Main\StatusBar_ID, 1, "Block: "+Hex(*Object\Cursor[1])+" - "+Hex(*Object\Cursor[0]-1))
        StatusBarText(Window_Main\StatusBar_ID, 2, "Length: "+Hex(*Object\Cursor[0]-*Object\Cursor[1]))
      EndIf
    Else
      StatusBarText(Window_Main\StatusBar_ID, 1, "")
      StatusBarText(Window_Main\StatusBar_ID, 2, "")
    EndIf
  EndIf
  
  ProcedureReturn #True
EndProcedure

Procedure Object_Data_Update(*Object.Object, Move_Data.q, Size.q, Reload)
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  If Move_Data
    Memory_Range_Move(*Object\Data, Move_Data, *Object\Data, 0, *Object\Data_Size)
    Memory_Range_Move(*Object\Metadata, Move_Data, *Object\Metadata, 0, *Object\Data_Size)
    
    If Move_Data >  *Object\Data_Size : Move_Data =  *Object\Data_Size : EndIf
    If Move_Data < -*Object\Data_Size : Move_Data = -*Object\Data_Size : EndIf
    If Move_Data > 0 ; #### Upwards
      Data_Source_Get(*Object\Data_Source, *Object\Data_Offset+*Object\Data_Size-Move_Data, Move_Data, *Object\Data+*Object\Data_Size-Move_Data, *Object\Metadata+*Object\Data_Size-Move_Data)
    ElseIf Move_Data < 0 ; #### Downwards
      Data_Source_Get(*Object\Data_Source, *Object\Data_Offset, -Move_Data, *Object\Data, *Object\Metadata)
    EndIf
  EndIf
  
  Protected Size_Diff.q = Size - *Object\Data_Size
  If Size >= 0 And Size_Diff
    If Size > 0
      If *Object\Data
        *Object\Data = ReAllocateMemory(*Object\Data, Size)
      Else
        *Object\Data = AllocateMemory(Size)
      EndIf
      If *Object\Metadata
        *Object\Metadata = ReAllocateMemory(*Object\Metadata, Size)
      Else
        *Object\Metadata = AllocateMemory(Size)
      EndIf
      If Size_Diff > 0
        Data_Source_Get(*Object\Data_Source, *Object\Data_Offset+*Object\Data_Size, Size_Diff, *Object\Data+*Object\Data_Size, *Object\Metadata+*Object\Data_Size)
      EndIf
      *Object\Data_Size = MemorySize(*Object\Data)
      *Object\Metadata_Size = MemorySize(*Object\Metadata)
    Else
      FreeMemory(*Object\Data)
      FreeMemory(*Object\Metadata)
      *Object\Data = 0
      *Object\Metadata = 0
      *Object\Data_Size = 0
      *Object\Metadata_Size = 0
    EndIf
  EndIf
  
  If Reload
    Data_Source_Get(*Object\Data_Source, *Object\Data_Offset, *Object\Data_Size, *Object\Data, *Object\Metadata)
  EndIf
  
  ProcedureReturn #True
EndProcedure

Procedure Object_ScrollBar_Update(*Object.Object, Scroll_Pos.q=-1)
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  *Object\View_Scroll_Range = *Object\Total_Lines
  If *Object\View_Scroll_Range < 1 : *Object\View_Scroll_Range = 1 : EndIf
  *Object\View_Scroll_Divider = 1 + *Object\View_Scroll_Range >> 30
  If *Object\View_Scroll_Divider < 1 : *Object\View_Scroll_Divider = 1 : EndIf
  
  *Object\View_Scroll_Page = (*Object\Editor_Height / *Object\Font_Height) - 2
  
  SetGadgetAttribute(*Object\ScrollBar[0], #PB_ScrollBar_Minimum, 0)
  SetGadgetAttribute(*Object\ScrollBar[0], #PB_ScrollBar_Maximum, Int_Divide_RUP(*Object\View_Scroll_Range, *Object\View_Scroll_Divider) + Int_Divide_RUP(*Object\View_Scroll_Page, *Object\View_Scroll_Divider))
  SetGadgetAttribute(*Object\ScrollBar[0], #PB_ScrollBar_PageLength, Int_Divide_RUP(*Object\View_Scroll_Page, *Object\View_Scroll_Divider))
  
  If Scroll_Pos >= 0
    SetGadgetState(*Object\ScrollBar[0], Int_Divide_RUP(Scroll_Pos, *Object\View_Scroll_Divider))
  EndIf
EndProcedure

Procedure Object_View_Redo(*Object.Object, Width, Height, Scroll_Pos.q, Cursor_0.q, Cursor_1.q, Cursor_Nibble, Redraw=0)
  Protected Total_Size.q, Temp_Size.q
  
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  *Object\Font_Width = Main\Font_Width
  *Object\Font_Height = Main\Font_Height
  
  ; #### Forced Redo/Redraw
  If Redraw
    Redraw = 1
    
    *Object\Total_Lines = 1 + (*Object\Total_Size / *Object\Rows)
    
    *Object\View_Lines = (*Object\Editor_Height / *Object\Font_Height) - 1
    If *Object\View_Lines > (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
      *Object\View_Lines = (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
    EndIf
    
    Temp_Size = *Object\Total_Size - *Object\Data_Offset
    If Temp_Size > *Object\View_Lines * *Object\Rows
      Temp_Size = *Object\View_Lines * *Object\Rows
    EndIf
    Object_Data_Update(*Object, 0, Temp_Size, 0)
    
    Object_ScrollBar_Update(*Object)
  EndIf
  
  ; #### Redo Total_Size
  Total_Size = Data_Source_Get_Size(*Object\Data_Source)
  If Total_Size >= 0 And *Object\Total_Size <> Total_Size
    Redraw = 1
    
    *Object\Total_Size = Total_Size
    
    *Object\Total_Lines = 1 + (*Object\Total_Size / *Object\Rows)
    
    *Object\View_Lines = (*Object\Editor_Height / *Object\Font_Height) - 1
    If *Object\View_Lines > (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
      *Object\View_Lines = (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
    EndIf
    
    Temp_Size = *Object\Total_Size - *Object\Data_Offset
    If Temp_Size > *Object\View_Lines * *Object\Rows
      Temp_Size = *Object\View_Lines * *Object\Rows
    EndIf
    Object_Data_Update(*Object, 0, Temp_Size, 0)
    
    Object_ScrollBar_Update(*Object)
  EndIf
  
  ; #### Redo Window Size
  If Width >= 0 And Height >= 0
    If *Object\Width <> Width Or *Object\Height <> Height
      Redraw = 1
      
      *Object\Width = Width
      *Object\Height = Height
      
      *Object\Editor_Width = Width - 17
      *Object\Editor_Height = Height
      
      *Object\View_Lines = (*Object\Editor_Height / *Object\Font_Height) - 1
      If *Object\View_Lines > (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
        *Object\View_Lines = (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
      EndIf
      
      Temp_Size = *Object\Total_Size - *Object\Data_Offset
      If Temp_Size > *Object\View_Lines * *Object\Rows
        Temp_Size = *Object\View_Lines * *Object\Rows
      EndIf
      Object_Data_Update(*Object, 0, Temp_Size, 0)
      
      ResizeGadget(*Object\ScrollBar[0], *Object\Width-17, 0, 17, *Object\Height)
      ResizeGadget(*Object\Canvas, 0, 0,*Object\Editor_Width, *Object\Editor_Height)
      
      Object_ScrollBar_Update(*Object)
    EndIf
  EndIf
  
  ; #### Redo Cursors
  If Cursor_0 >= 0 And *Object\Cursor[0] <> Cursor_0
    Redraw = 1
    *Object\Cursor[0] = Cursor_0
    
    If *Object\Cursor[0] > *Object\Total_Size : *Object\Cursor[0] = *Object\Total_Size : *Object\Cursor_Nibble = 0 : EndIf
    
    If *Object\Cursor[0] / *Object\Rows < *Object\View_Scroll_Pos
      Scroll_Pos = *Object\Cursor[0] / *Object\Rows
      Object_ScrollBar_Update(*Object, Scroll_Pos)
    EndIf
    If *Object\Cursor[0] / *Object\Rows > *Object\View_Scroll_Pos + *Object\View_Scroll_Page - 1
      Scroll_Pos = *Object\Cursor[0] / *Object\Rows - *Object\View_Scroll_Page + 1
      Object_ScrollBar_Update(*Object, Scroll_Pos)
    EndIf
  EndIf
  
  If Cursor_1 >= 0 And *Object\Cursor[1] <> Cursor_1
    Redraw = 1
    *Object\Cursor[1] = Cursor_1
  EndIf
  
  If Cursor_Nibble >= 0 And *Object\Cursor_Nibble <> Cursor_Nibble
    Redraw = 1
    *Object\Cursor_Nibble = Cursor_Nibble
  EndIf
  
  If *Object\Cursor[0] > *Object\Total_Size : *Object\Cursor[0] = *Object\Total_Size : *Object\Cursor_Nibble = 0 : EndIf
  If *Object\Cursor[1] > *Object\Total_Size : *Object\Cursor[1] = *Object\Total_Size : EndIf
  
  ; #### Redo Scrollpos
  If Scroll_Pos >= 0 And *Object\View_Scroll_Pos <> Scroll_Pos
    Redraw = 1
    
    If Scroll_Pos > *Object\View_Scroll_Range-1
      Scroll_Pos = *Object\View_Scroll_Range-1
    EndIf
    
    Diff = (Scroll_Pos * *Object\Rows) - *Object\Data_Offset
    
    *Object\View_Scroll_Pos = Scroll_Pos
    *Object\Data_Offset = Scroll_Pos * *Object\Rows
    
    *Object\View_Lines = (*Object\Editor_Height / *Object\Font_Height) - 1
    If *Object\View_Lines > (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
      *Object\View_Lines = (1 + (*Object\Total_Size - *Object\Data_Offset) / *Object\Rows)
    EndIf
    
    Object_Data_Update(*Object, Diff, *Object\View_Lines * *Object\Rows, 0)
  EndIf
  
  If *Object\Total_Size > 0
    *Object\View_Offset_Digits = Len(Hex(*Object\Total_Size-1))
  Else
    *Object\View_Offset_Digits = 8
  EndIf
  If *Object\View_Offset_Digits < 8 : *Object\View_Offset_Digits = 8 : EndIf
  
  *Object\View_O_X[0] = 10
  *Object\View_O_Y[0] = 10
  *Object\View_O_X[1] = *Object\View_O_X[0] + *Object\Font_Width * *Object\View_Offset_Digits
  *Object\View_O_Y[1] = *Object\View_O_Y[0] + *Object\Font_Height
  *Object\View_O_X[2] = *Object\View_O_X[1] + *Object\Font_Width * 2
  *Object\View_O_Y[2] = *Object\View_O_Y[1] + 5
  *Object\View_O_X[3] = *Object\View_O_X[2] + *Object\Font_Width * (*Object\Rows * 3 - 1)
  *Object\View_O_Y[3] = *Object\View_O_Y[2] + *Object\Font_Height * *Object\View_Lines
  *Object\View_O_X[4] = *Object\View_O_X[3] + *Object\Font_Width * 2
  *Object\View_O_Y[4] = *Object\View_O_Y[3] + 0
  *Object\View_O_X[5] = *Object\View_O_X[4] + *Object\Font_Width * *Object\Rows
  *Object\View_O_Y[5] = *Object\View_O_Y[4] + 0
  
  If Redraw
    Object_Redraw(*Object)
  EndIf
  
  ProcedureReturn #True
EndProcedure

Procedure Object_Delete(*Object.Object)
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  If *Object\Hilbert
    Object_Hilbert_Destroy(*Object\Hilbert)
  EndIf
  
  If *Object\Window_ID
    CloseWindow(*Object\Window_ID)
  EndIf
  
  If *Object\Data_Source
    Data_Source_Destroy(*Object\Data_Source)
  EndIf
  
  ChangeCurrentElement(Object(), *Object)
  DeleteElement(Object())
  
  Window_Main_Panel_Rebuild(0)
  
  ProcedureReturn #True
EndProcedure

Procedure Object_Add(Name.s, Short_Name.s, *Data_Source.Data_Source)
  Protected *Object.Object
  
  If Not *Data_Source
    ProcedureReturn #False
  EndIf
  
  LastElement(Object())
  If Not AddElement(Object())
    ProcedureReturn #False
  EndIf
  
  Object()\Data_Source = *Data_Source
  Object()\Name = Name
  Object()\Short_Name = Short_Name
  Object()\Window_ID = AddGadgetItem(Window_Main\MDI, #PB_Any, Name, 0, #PB_Window_Maximize | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget | #PB_Window_SystemMenu | #PB_Window_SizeGadget)
  If Not Object()\Window_ID
    Object_Delete(Object())
    ProcedureReturn #False
  EndIf
  
  SmartWindowRefresh(Object()\Window_ID, 1)
  
  Object()\Rows = 16
  
  Object()\Canvas = CanvasGadget(#PB_Any, 0, 0, Object()\Editor_Width, Object()\Editor_Height, #PB_Canvas_Keyboard)
  Object()\ScrollBar [0] = ScrollBarGadget(#PB_Any, Object()\Width-17, 0, 17, Object()\Height, 0, 0, 0, #PB_ScrollBar_Vertical)
  
  Object()\Data_Size = 0
  Object_View_Redo(Object(), WindowWidth(Object()\Window_ID), WindowHeight(Object()\Window_ID), 0, 0, 0, 0)
  
  *Object = Object()
  
  Window_Main_Panel_Rebuild(Object()\Window_ID)
  
  ProcedureReturn *Object
EndProcedure

Procedure Object_Write(*Object.Object, Offset.q, *Write_Data, Data_Length.i, Length_Diff.q)
  If Not *Object
    ProcedureReturn #False
  EndIf
  
  If Not *Object\Data_Source
    ProcedureReturn #False
  EndIf
  
  If Not Data_Source_Set_Writeable(*Object\Data_Source, 1)
    ProcedureReturn #False
  EndIf
  
  If Not Data_Source_Set(*Object\Data_Source, Offset, Data_Length, *Write_Data)
    ProcedureReturn #False
  EndIf
  
  Data_Offset.q = Offset - *Object\Data_Offset
  If Data_Offset >= 0 And Data_Offset < *Object\Data_Size
    Temp_Size = Data_Length
    If Temp_Size > *Object\Data_Size - Data_Offset : Temp_Size = *Object\Data_Size - Data_Offset : EndIf
    CopyMemory(*Write_Data, *Object\Data+Data_Offset, Temp_Size)
  EndIf
  
  ProcedureReturn #True
EndProcedure

Procedure WinCallback(hWnd, uMsg, wParam, lParam)
  Protected SCROLLINFO.SCROLLINFO
  
  ; Windows fllt die Parameter automatisch, welche wir im Callback verwenden...
  
  PushListPosition(Object())
  
  ForEach Object()
    If Object()\Window_ID And WindowID(Object()\Window_ID) = hWnd
      
      Select uMsg
        Case #WM_VSCROLL
          Select wParam & $FFFF
            Case #SB_THUMBTRACK
              SCROLLINFO\fMask = #SIF_TRACKPOS
              SCROLLINFO\cbSize = SizeOf(SCROLLINFO)
              GetScrollInfo_(lParam, #SB_CTL, @SCROLLINFO)
              Object_View_Redo(Object(), -1, -1, SCROLLINFO\nTrackPos * Object()\View_Scroll_Divider, -1, -1, -1)
            Case #SB_PAGEUP
              Scroll_Pos.q = Object()\View_Scroll_Pos - Object()\View_Scroll_Page
              If Scroll_Pos < 0 : Scroll_Pos = 0 : EndIf
              If Scroll_Pos > Object()\View_Scroll_Range : Scroll_Pos = Object()\View_Scroll_Range : EndIf
              Object_View_Redo(Object(), -1, -1, Scroll_Pos, -1, -1, -1)
            Case #SB_PAGEDOWN
              Scroll_Pos.q = Object()\View_Scroll_Pos + Object()\View_Scroll_Page
              If Scroll_Pos < 0 : Scroll_Pos = 0 : EndIf
              If Scroll_Pos > Object()\View_Scroll_Range : Scroll_Pos = Object()\View_Scroll_Range : EndIf
              Object_View_Redo(Object(), -1, -1, Scroll_Pos, -1, -1, -1)
            Case #SB_LINEUP
              Scroll_Pos.q = Object()\View_Scroll_Pos - 1
              If Scroll_Pos < 0 : Scroll_Pos = 0 : EndIf
              If Scroll_Pos > Object()\View_Scroll_Range : Scroll_Pos = Object()\View_Scroll_Range : EndIf
              Object_View_Redo(Object(), -1, -1, Scroll_Pos, -1, -1, -1)
            Case #SB_LINEDOWN
              Scroll_Pos.q = Object()\View_Scroll_Pos + 1
              If Scroll_Pos < 0 : Scroll_Pos = 0 : EndIf
              If Scroll_Pos > Object()\View_Scroll_Range : Scroll_Pos = Object()\View_Scroll_Range : EndIf
              Object_View_Redo(Object(), -1, -1, Scroll_Pos, -1, -1, -1)
          EndSelect
      EndSelect
      
      Break
    EndIf
  Next
  
  PopListPosition(Object())
  
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

SetWindowCallback(@WinCallback())

Procedure Object_Event(*Object.Object, Event, Event_Type)
  Select Event
    Case #WM_CHAR
      If *Object\Mark_Mode = #Object_Mark_Mode_Ascii_Write
        Char = EventwParam()
        If Char >= 32 And Char <= 255
          If Object_Write(*Object, *Object\Cursor[0], @Char, 1, 0)
            Object_View_Redo(*Object, -1, -1, -1, *Object\Cursor[0]+1, *Object\Cursor[0]+1, 0)
          EndIf
        EndIf
      EndIf
    
    Case #PB_Event_ActivateWindow
      Window_Main_Panel_Rebuild(*Object\Window_ID)
      
    Case #PB_Event_SizeWindow, #PB_Event_MaximizeWindow, #PB_Event_RestoreWindow, #PB_Event_MinimizeWindow, #PB_Event_Repaint
      Object_View_Redo(*Object, WindowWidth(*Object\Window_ID), WindowHeight(*Object\Window_ID), -1, -1, -1, -1)
    
    Case #PB_Event_Gadget
      Select EventGadget()
        Case *Object\Canvas
          Select Event_Type
            Case #PB_EventType_KeyDown
              Key = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_Key)
              Modifiers = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_Modifiers)
              Select Key
                Case #PB_Shortcut_Up
                  Cursor.q = *Object\Cursor[0] - *Object\Rows
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, -1)
                  EndIf
                  
                Case #PB_Shortcut_Down
                  Cursor.q = *Object\Cursor[0] + *Object\Rows
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, -1)
                  EndIf
                  
                Case #PB_Shortcut_Right
                  Cursor.q = *Object\Cursor[0] + 1
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                  EndIf
                  
                Case #PB_Shortcut_Left
                  Cursor.q = *Object\Cursor[0] - 1
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                  EndIf
                  
                Case #PB_Shortcut_Home
                  ;If Modifiers & #PB_Canvas_Control
                    Cursor.q = 0
                  ;Else
                  ;  Cursor.q = (Int_Divide_RUP(*Object\Cursor[0], *Object\Rows)-1) * *Object\Rows
                  ;EndIf
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                  EndIf
                  
                Case #PB_Shortcut_End
                  ;If Modifiers & #PB_Canvas_Control
                    Cursor.q = *Object\Total_Size
                  ;Else
                  ;  Cursor.q = *Object\Cursor[0] / *Object\Rows * *Object\Rows + *Object\Rows
                  ;EndIf
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                  EndIf
                  
                Case #PB_Shortcut_Prior
                  Cursor.q = *Object\Cursor[0] - *Object\View_Scroll_Page * *Object\Rows
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, -1)
                  EndIf
                  
                Case #PB_Shortcut_Next
                  Cursor.q = *Object\Cursor[0] + *Object\View_Scroll_Page * *Object\Rows
                  If Modifiers & #PB_Canvas_Shift
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                  Else
                    Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, -1)
                  EndIf
                  
                Case #PB_Shortcut_A
                  If Modifiers & #PB_Canvas_Control
                    Object_View_Redo(*Object, -1, -1, -1, 0, *Object\Total_Size, 0)
                  EndIf
                  
                Case #PB_Shortcut_C
                  If Modifiers & #PB_Canvas_Control
                    If *Object\Cursor[0] <> *Object\Cursor[1]
                      If *Object\Cursor[0] < *Object\Cursor[1]
                        Start.q = *Object\Cursor[0]
                        Length.q = *Object\Cursor[1]-*Object\Cursor[0]
                        *Text.String = AllocateMemory(Length + 2)
                        *Metadata.String = AllocateMemory(Length + 2)
                        Data_Source_Get(*Object\Data_Source, Start, Length, *Text, *Metadata)
                        SetClipboardText(PeekS(*Text, Length, #PB_Ascii))
                        FreeMemory(*Text)
                        FreeMemory(*Metadata)
                      Else
                        Start.q = *Object\Cursor[1]
                        Length.q = *Object\Cursor[0]-*Object\Cursor[1]
                        *Text.String = AllocateMemory(Length + 2)
                        *Metadata.String = AllocateMemory(Length + 2)
                        Data_Source_Get(*Object\Data_Source, Start, Length, *Text, *Metadata)
                        SetClipboardText(PeekS(*Text, Length, #PB_Ascii))
                        FreeMemory(*Text)
                        FreeMemory(*Metadata)
                      EndIf
                    EndIf
                  EndIf
                  
                Case #PB_Shortcut_V
                  If Modifiers & #PB_Canvas_Control
                    If *Object\Cursor[0] < *Object\Cursor[1]
                      Text.s = GetClipboardText()
                      Start.q = *Object\Cursor[0]
                      Length.q = Len(Text)
                      *Text.String = AllocateMemory(Length + 2)
                      PokeS(*Text, Text, Length, #PB_Ascii)
                      If Object_Write(*Object, Start, *Text, Length, 0)
                        Object_View_Redo(*Object, -1, -1, -1, Start+Length, Start+Length, 0)
                      EndIf
                      FreeMemory(*Text)
                    Else
                      Text.s = GetClipboardText()
                      Start.q = *Object\Cursor[1]
                      Length.q = Len(Text)
                      *Text.String = AllocateMemory(Length + 2)
                      PokeS(*Text, Text, Length, #PB_Ascii)
                      If Object_Write(*Object, Start, *Text, Length, 0)
                        Object_View_Redo(*Object, -1, -1, -1, Start+Length, Start+Length, 0)
                      EndIf
                      FreeMemory(*Text)
                    EndIf
                  EndIf
                  
              EndSelect
              If Modifiers = 0 And (Key >= #PB_Shortcut_0 And Key <= #PB_Shortcut_9) Or (Key >= #PB_Shortcut_Pad0 And Key <= #PB_Shortcut_Pad9) Or (Key >= #PB_Shortcut_A And Key <= #PB_Shortcut_F)
                If *Object\Mark_Mode = #Object_Mark_Mode_Hex_Write
                  Select Key
                    Case #PB_Shortcut_0, #PB_Shortcut_Pad0 : Char = $0
                    Case #PB_Shortcut_1, #PB_Shortcut_Pad1 : Char = $1
                    Case #PB_Shortcut_2, #PB_Shortcut_Pad2 : Char = $2
                    Case #PB_Shortcut_3, #PB_Shortcut_Pad3 : Char = $3
                    Case #PB_Shortcut_4, #PB_Shortcut_Pad4 : Char = $4
                    Case #PB_Shortcut_5, #PB_Shortcut_Pad5 : Char = $5
                    Case #PB_Shortcut_6, #PB_Shortcut_Pad6 : Char = $6
                    Case #PB_Shortcut_7, #PB_Shortcut_Pad7 : Char = $7
                    Case #PB_Shortcut_8, #PB_Shortcut_Pad8 : Char = $8
                    Case #PB_Shortcut_9, #PB_Shortcut_Pad9 : Char = $9
                    Case #PB_Shortcut_A : Char = $A
                    Case #PB_Shortcut_B : Char = $B
                    Case #PB_Shortcut_C : Char = $C
                    Case #PB_Shortcut_D : Char = $D
                    Case #PB_Shortcut_E : Char = $E
                    Case #PB_Shortcut_F : Char = $F
                  EndSelect
                  Data_Source_Get(*Object\Data_Source, *Object\Cursor[0], 1, @Value, @Dummy)
                  If *Object\Cursor_Nibble = 0
                    Value & $0F
                    Value | Char << 4
                    If Object_Write(*Object, *Object\Cursor[0], @Value, 1, 0)
                      Object_View_Redo(*Object, -1, -1, -1, *Object\Cursor[0], *Object\Cursor[0], 1)
                    EndIf
                  Else
                    Value & $F0
                    Value | Char
                    If Object_Write(*Object, *Object\Cursor[0], @Value, 1, 0)
                      Object_View_Redo(*Object, -1, -1, -1, *Object\Cursor[0]+1, *Object\Cursor[0]+1, 0)
                    EndIf
                  EndIf
                EndIf
              EndIf
            
            Case #PB_EventType_MouseMove
              X = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_MouseX)
              Y = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_MouseY)
              If X >= *Object\View_O_X[2] And X < *Object\View_O_X[3] And Y >= *Object\View_O_Y[2] And Y < *Object\View_O_Y[3]
                SetGadgetAttribute(*Object\Canvas, #PB_Canvas_Cursor, #PB_Cursor_IBeam)
              ElseIf X >= *Object\View_O_X[4] And X < *Object\View_O_X[5] And Y >= *Object\View_O_Y[2] And Y < *Object\View_O_Y[3]
                SetGadgetAttribute(*Object\Canvas, #PB_Canvas_Cursor, #PB_Cursor_IBeam)
              Else
                SetGadgetAttribute(*Object\Canvas, #PB_Canvas_Cursor, #PB_Cursor_Default)
              EndIf
              Select *Object\Mark_Mode
                Case #Object_Mark_Mode_Hex
                  If X < *Object\View_O_X[2] : X = *Object\View_O_X[2] : EndIf
                  If X > *Object\View_O_X[3] : X = *Object\View_O_X[3] : EndIf
                  X - *Object\View_O_X[2] + 4
                  Y - *Object\View_O_Y[2]
                  Cursor.q = *Object\Data_Offset
                  Cursor + (*Object\Font_Width + X) / (*Object\Font_Width * 3)
                  Cursor + Y / *Object\Font_Height * *Object\Rows
                  If Cursor < 0 : Cursor = (*Object\Font_Width + X) / (*Object\Font_Width * 3) : EndIf
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                Case #Object_Mark_Mode_Ascii
                  If X < *Object\View_O_X[4] : X = *Object\View_O_X[4] : EndIf
                  If X > *Object\View_O_X[5] : X = *Object\View_O_X[5] : EndIf
                  X - *Object\View_O_X[4] + 4
                  Y - *Object\View_O_Y[2]
                  Cursor.q = *Object\Data_Offset
                  Cursor + X / *Object\Font_Width
                  Cursor + Y / *Object\Font_Height * *Object\Rows
                  If Cursor < 0 : Cursor = X / *Object\Font_Width : EndIf
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
              EndSelect
              
            Case #PB_EventType_MouseWheel
              Scroll_Pos.q = *Object\View_Scroll_Pos
              Scroll_Pos - GetGadgetAttribute(*Object\Canvas, #PB_Canvas_WheelDelta) * 3
              If Scroll_Pos < 0 : Scroll_Pos = 0 : EndIf
              If Scroll_Pos > *Object\View_Scroll_Range : Scroll_Pos = *Object\View_Scroll_Range : EndIf
              SetGadgetState(*Object\ScrollBar[0], Int_Divide_RUP(Scroll_Pos, *Object\View_Scroll_Divider))
              Object_View_Redo(*Object, -1, -1, Scroll_Pos, -1, -1, -1)
              
            Case #PB_EventType_LeftButtonDown
              X = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_MouseX)
              Y = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_MouseY)
              Modifiers = GetGadgetAttribute(*Object\Canvas, #PB_Canvas_Modifiers)
              If X >= *Object\View_O_X[2] And X < *Object\View_O_X[3] And Y >= *Object\View_O_Y[2] And Y < *Object\View_O_Y[3]
                X - *Object\View_O_X[2] + 4
                Y - *Object\View_O_Y[2]
                Cursor = *Object\Data_Offset
                Cursor + (*Object\Font_Width + X) / (*Object\Font_Width * 3)
                Cursor + Y / *Object\Font_Height * *Object\Rows
                *Object\Mark_Mode = #Object_Mark_Mode_Hex
                If Modifiers & #PB_Canvas_Shift
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                Else
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                EndIf
                
              ElseIf X >= *Object\View_O_X[4] And X < *Object\View_O_X[5] And Y >= *Object\View_O_Y[2] And Y < *Object\View_O_Y[3]
                X - *Object\View_O_X[4] + 4
                Y - *Object\View_O_Y[2]
                Cursor = *Object\Data_Offset
                Cursor + X / *Object\Font_Width
                Cursor + Y / *Object\Font_Height * *Object\Rows
                *Object\Mark_Mode = #Object_Mark_Mode_Ascii
                If Modifiers & #PB_Canvas_Shift
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, -1, 0)
                Else
                  Object_View_Redo(*Object, -1, -1, -1, Cursor, Cursor, 0)
                EndIf
              EndIf
              
            Case #PB_EventType_LeftButtonUp
              Select *Object\Mark_Mode
                Case #Object_Mark_Mode_Ascii
                  *Object\Mark_Mode = #Object_Mark_Mode_Ascii_Write
                Case #Object_Mark_Mode_Hex
                  *Object\Mark_Mode = #Object_Mark_Mode_Hex_Write
              EndSelect
              
          EndSelect
      EndSelect
    
    Case #PB_Event_CloseWindow
      Object_Delete(*Object)
      
  EndSelect
EndProcedure

; #################################################### Initstuff #################################################

; #################################################### Datasections ##############################################
; IDE Options = PureBasic 4.60 RC 2 (Windows - x64)
; CursorPosition = 475
; FirstLine = 473
; Folding = --
; EnableXP
; DisableDebugger