
; ############################################ Variablen ####################################################

Structure Object_Find_Main
  
EndStructure
Global Object_Find_Main.Object_Find_Main

Structure Window_Object_Find
  ID.i
  Text.i [10]
  String.i
  ComboBox.i [10]
  CheckBox.i [10]
  Button.i [10]
  Frame3D.i [10]
EndStructure
Global Window_Object_Find.Window_Object_Find

; ############################################ Proceduren ####################################################

Procedure Window_Object_Find(Open)
  If Open = 1 And Window_Object_Find\ID = 0
    
    Window_Object_Find\ID = OpenWindow(#PB_Any, 0, 0, 400, 200, "Search", #PB_Window_WindowCentered , WindowID(Window_Main\ID))
    If Window_Object_Find\ID
      If UseGadgetList(WindowID(Window_Object_Find\ID))
        
        AddKeyboardShortcut(Window_Object_Find\ID, #PB_Shortcut_Return, 0)
        
        Window_Object_Find\Text[0] = TextGadget(#PB_Any, 10, 10, 80, 20, "Keyword:", #PB_Text_Right)
        Window_Object_Find\String = StringGadget(#PB_Any, 100, 10, 290, 20, "")
        Window_Object_Find\Text[1] = TextGadget(#PB_Any, 10, 30, 80, 20, "Type:", #PB_Text_Right)
        Window_Object_Find\ComboBox[0] = ComboBoxGadget(#PB_Any, 100, 30, 290, 20)
        AddGadgetItem(Window_Object_Find\ComboBox[0], 0, "String")
        AddGadgetItem(Window_Object_Find\ComboBox[0], 1, "Raw-Data")
        AddGadgetItem(Window_Object_Find\ComboBox[0], 2, "Integer")
        AddGadgetItem(Window_Object_Find\ComboBox[0], 3, "Float")
        SetGadgetState(Window_Object_Find\ComboBox[0], 0)
        
        Window_Object_Find\Frame3D[0] = Frame3DGadget(#PB_Any, 10, 60, 200, 100, "")
        
        ; #### String
        Window_Object_Find\CheckBox[0] = CheckBoxGadget(#PB_Any, 20, 80, 180, 20, "Unicode")
        Window_Object_Find\CheckBox[1] = CheckBoxGadget(#PB_Any, 20, 100, 180, 20, "Case-Sensitive")
        
        ; #### Raw-Data
        
        ; #### Integer
        Window_Object_Find\ComboBox[1] = ComboBoxGadget(#PB_Any, 20, 80, 180, 20)
        AddGadgetItem(Window_Object_Find\ComboBox[1], 0, "8 Bit")
        AddGadgetItem(Window_Object_Find\ComboBox[1], 1, "16 Bit")
        AddGadgetItem(Window_Object_Find\ComboBox[1], 2, "32 Bit")
        AddGadgetItem(Window_Object_Find\ComboBox[1], 3, "64 Bit")
        SetGadgetState(Window_Object_Find\ComboBox[1], 2)
        Window_Object_Find\ComboBox[2] = ComboBoxGadget(#PB_Any, 20, 100, 180, 20)
        AddGadgetItem(Window_Object_Find\ComboBox[2], 0, "Little Endian (x86, x64, ...)")
        AddGadgetItem(Window_Object_Find\ComboBox[2], 1, "Big Endian")
        SetGadgetState(Window_Object_Find\ComboBox[2], 0)
        
        ; #### Float
        Window_Object_Find\ComboBox[3] = ComboBoxGadget(#PB_Any, 20, 80, 180, 20)
        AddGadgetItem(Window_Object_Find\ComboBox[3], 0, "32 Bit")
        AddGadgetItem(Window_Object_Find\ComboBox[3], 1, "64 Bit")
        SetGadgetState(Window_Object_Find\ComboBox[3], 0)
        Window_Object_Find\ComboBox[4] = ComboBoxGadget(#PB_Any, 20, 100, 180, 20)
        AddGadgetItem(Window_Object_Find\ComboBox[4], 0, "Little Endian (x86, x64, ...)")
        AddGadgetItem(Window_Object_Find\ComboBox[4], 1, "Big Endian")
        SetGadgetState(Window_Object_Find\ComboBox[4], 0)
        
        HideGadget(Window_Object_Find\CheckBox[0], 0)
        HideGadget(Window_Object_Find\CheckBox[1], 0)
        HideGadget(Window_Object_Find\ComboBox[1], 1)
        HideGadget(Window_Object_Find\ComboBox[2], 1)
        HideGadget(Window_Object_Find\ComboBox[3], 1)
        HideGadget(Window_Object_Find\ComboBox[4], 1)
        
        Window_Object_Find\Button[0] = ButtonGadget(#PB_Any, 200, 165, 90, 25, "Ok")
        Window_Object_Find\Button[1] = ButtonGadget(#PB_Any, 300, 165, 90, 25, "Cancel")
        
        SetActiveGadget(Window_Object_Find\String)
        
      EndIf
    EndIf
  ElseIf Open = 0 And Window_Object_Find\ID
    CloseWindow(Window_Object_Find\ID)
    Window_Object_Find\ID = 0
  EndIf
EndProcedure

Procedure Object_Find(*Object.Object, Start_Offset.q, Search_Size.q, *Keydata.Ascii, Size.i)
  Protected Position.q, Temp_Size.q, *Pointer.Ascii
  Protected Result.q = -1
  
  If Not *Object
    ProcedureReturn -1
  EndIf
  
  If Not *Keydata
    ProcedureReturn -1
  EndIf
  
  If Size <= 0
    ProcedureReturn -1
  EndIf
  
  If Search_Size <= 0
    ProcedureReturn -1
  EndIf
  
  If Window_Object_Find\ID
    Window_ID = OpenWindow(#PB_Any, 0, 0, 400, 75, "Search", #PB_Window_WindowCentered, WindowID(Window_Object_Find\ID))
  Else
    Window_ID = OpenWindow(#PB_Any, 0, 0, 400, 75, "Search", #PB_Window_WindowCentered, WindowID(Window_Main\ID))
  EndIf
  If UseGadgetList(WindowID(Window_ID))
    ProgressBar = ProgressBarGadget(#PB_Any, 10, 10, 380, 20, 0, 1024)
    Button = ButtonGadget(#PB_Any, 300, 40, 90, 25, "Cancel")
  EndIf
  
  Search_Size_Old.q = Search_Size
  
  Position = Start_Offset
  
  Protected *Temp_Check = AllocateMemory(Size)
  Protected *Temp_Data = AllocateMemory(65536)
  Protected *Temp_Metadata = AllocateMemory(65536)
  
  ForEach *Object\Range()
    If *Object\Range()\Offset + *Object\Range()\Size > Position
      
      If *Object\Range()\Metadata & #Object_Metadata_Readable
        While Search_Size
          Temp_Size = Search_Size
          If Temp_Size > 65536 : Temp_Size = 65536 : EndIf
          If Temp_Size > *Object\Range()\Size - (Position - *Object\Range()\Offset) : Temp_Size = *Object\Range()\Size - (Position - *Object\Range()\Offset) : EndIf
          If Temp_Size
            Data_Source_Get(*Object\Data_Source, Position, Temp_Size, *Temp_Data, *Temp_Metadata)
            
            For i = 0 To Temp_Size-1
              *Pointer = *Temp_Data + i
              If *Pointer\a = *Keydata\a
                Data_Source_Get(*Object\Data_Source, Position, Size, *Temp_Check, *Temp_Metadata)
                If CompareMemory(*Temp_Check, *Keydata, Size)
                  Result = Position
                  Break 3
                EndIf
              EndIf
              Position + 1
            Next
            
            Search_Size - Temp_Size
            
            If Timer < ElapsedMilliseconds()
              Timer = ElapsedMilliseconds() + 100
              SetGadgetState(ProgressBar, 1024 - (Search_Size)/(1+Search_Size_Old/1024))
              While WindowEvent()
                If EventWindow() = Window_ID
                  If EventGadget() = Button
                    Break 3
                  EndIf
                EndIf
              Wend
            EndIf
          Else
            Break
          EndIf
        Wend
      Else
        Position + *Object\Range()\Size - (Position - *Object\Range()\Offset)
        Search_Size - *Object\Range()\Size - (Position - *Object\Range()\Offset)
      EndIf
      
    EndIf
  Next
  
  CloseWindow(Window_ID)
  
  FreeMemory(*Temp_Check)
  FreeMemory(*Temp_Data)
  FreeMemory(*Temp_Metadata)
  
  ProcedureReturn Result
EndProcedure

Procedure Object_Find_Do()
  ForEach Object()
    If Object()\Window_ID = GetGadgetState(Window_Main\MDI)
      
      String.s = GetGadgetText(Window_Object_Find\String)
      
      If Object()\Last_Search_Keyword
        FreeMemory(Object()\Last_Search_Keyword)
        Object()\Last_Search_Keyword = 0
        Object()\Last_Search_Keyword_Length = 0
      EndIf
      
      Select GetGadgetState(Window_Object_Find\ComboBox[0])
        Case 0
          If GetGadgetState(Window_Object_Find\CheckBox[0])
            Object()\Last_Search_Keyword_Length = StringByteLength(String, #PB_Unicode)
            Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length+2)
            PokeS(Object()\Last_Search_Keyword, String, Len(String), #PB_Unicode)
          Else
            Object()\Last_Search_Keyword_Length = StringByteLength(String, #PB_Ascii)
            Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length+1)
            PokeS(Object()\Last_Search_Keyword, String, Len(String), #PB_Ascii)
          EndIf
          
        Case 1
          Fields = 1 + CountString(String, " ")
          Object()\Last_Search_Keyword_Length = Fields
          Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
          For i = 1 To Fields
            PokeA(Object()\Last_Search_Keyword+i-1, Val(StringField(String, i, " ")))
          Next
          
        Case 2
          Select GetGadgetState(Window_Object_Find\ComboBox[1])
            Case 0
              Object()\Last_Search_Keyword_Length = 1
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeA(Object()\Last_Search_Keyword, Val(String))
            Case 1
              Object()\Last_Search_Keyword_Length = 2
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeU(Object()\Last_Search_Keyword, Val(String))
            Case 2
              Object()\Last_Search_Keyword_Length = 4
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeL(Object()\Last_Search_Keyword, Val(String))
            Case 4
              Object()\Last_Search_Keyword_Length = 8
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeQ(Object()\Last_Search_Keyword, Val(String))
          EndSelect
          
        Case 3
          Select GetGadgetState(Window_Object_Find\ComboBox[3])
            Case 0
              Object()\Last_Search_Keyword_Length = 4
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeF(Object()\Last_Search_Keyword, ValF(String))
            Case 1
              Object()\Last_Search_Keyword_Length = 8
              Object()\Last_Search_Keyword = AllocateMemory(Object()\Last_Search_Keyword_Length)
              PokeD(Object()\Last_Search_Keyword, ValD(String))
          EndSelect
          
      EndSelect
      
      If Object()\Last_Search_Keyword
        Pos.q = Object_Find(Object(), Object()\Cursor[0], Object()\Total_Size - Object()\Cursor[0], Object()\Last_Search_Keyword, Object()\Last_Search_Keyword_Length)
        If Pos >= 0
          Object_View_Redo(Object(), -1, -1, -1, Pos, Pos+Object()\Last_Search_Keyword_Length, 0)
          Window_Object_Find(0)
        EndIf
      EndIf
      
    EndIf
  Next
EndProcedure

Procedure Object_Find_Continue()
  ForEach Object()
    If Object()\Window_ID = GetGadgetState(Window_Main\MDI)
      
      If Object()\Last_Search_Keyword
        Pos.q = Object_Find(Object(), Object()\Cursor[1], Object()\Total_Size - Object()\Cursor[1], Object()\Last_Search_Keyword, Object()\Last_Search_Keyword_Length)
        If Pos >= 0
          Object_View_Redo(Object(), -1, -1, -1, Pos, Pos+Object()\Last_Search_Keyword_Length, 0)
          Window_Object_Find(0)
        Else
          MessageRequester("Search", "Could't find it")
        EndIf
      EndIf
      
    EndIf
  Next
EndProcedure

Procedure Object_Find_Event(Event, Event_Type)
  
  Select Event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case Window_Object_Find\ComboBox[0]
          Select GetGadgetState(Window_Object_Find\ComboBox[0])
            Case 0
              HideGadget(Window_Object_Find\CheckBox[0], 0)
              HideGadget(Window_Object_Find\CheckBox[1], 0)
              HideGadget(Window_Object_Find\ComboBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[2], 1)
              HideGadget(Window_Object_Find\ComboBox[3], 1)
              HideGadget(Window_Object_Find\ComboBox[4], 1)
            Case 1
              HideGadget(Window_Object_Find\CheckBox[0], 1)
              HideGadget(Window_Object_Find\CheckBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[2], 1)
              HideGadget(Window_Object_Find\ComboBox[3], 1)
              HideGadget(Window_Object_Find\ComboBox[4], 1)
            Case 2
              HideGadget(Window_Object_Find\CheckBox[0], 1)
              HideGadget(Window_Object_Find\CheckBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[1], 0)
              HideGadget(Window_Object_Find\ComboBox[2], 0)
              HideGadget(Window_Object_Find\ComboBox[3], 1)
              HideGadget(Window_Object_Find\ComboBox[4], 1)
            Case 3
              HideGadget(Window_Object_Find\CheckBox[0], 1)
              HideGadget(Window_Object_Find\CheckBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[1], 1)
              HideGadget(Window_Object_Find\ComboBox[2], 1)
              HideGadget(Window_Object_Find\ComboBox[3], 0)
              HideGadget(Window_Object_Find\ComboBox[4], 0)
          EndSelect
        
        Case Window_Object_Find\Button [0]
          Object_Find_Do()
          
        Case Window_Object_Find\Button [1]
          Window_Object_Find(0)
        
      EndSelect
      
    Case #PB_Event_Menu
      Object_Find_Do()
      
  EndSelect
EndProcedure
; IDE Options = PureBasic 4.60 Beta 1 (Windows - x64)
; CursorPosition = 268
; FirstLine = 230
; Folding = -
; EnableXP
; DisableDebugger