
; ############################################ Variablen ####################################################

Structure Process_Main
  
EndStructure
Global Process_Main.Process_Main

Structure Window_Process
  ID.i
  Button.i [10]
  ListIcon.i
EndStructure
Global Window_Process.Window_Process

; ############################################ Proceduren ####################################################

Procedure Process_Debug_Privileges()
  hProc = GetCurrentProcess_()

  If Not OpenProcessToken_(hProc, #TOKEN_QUERY | #TOKEN_ADJUST_PRIVILEGES, @hToken)
    ProcedureReturn
  EndIf

  If Not LookupPrivilegeValue_(#Null, #SE_DEBUG_NAME, @luid.q)
    CloseHandle_(hToken)
    ProcedureReturn
  EndIf
  
  tp.TOKEN_PRIVILEGES
  tp\PrivilegeCount = 1
  tp\Privileges[0]\Luid\LowPart = luid & $FFFFFFFF
  tp\Privileges[0]\Luid\HighPart = luid >> 32
  tp\Privileges[0]\Attributes = #SE_PRIVILEGE_ENABLED

  If Not AdjustTokenPrivileges_(hToken, #False, tp, SizeOf(TOKEN_PRIVILEGES), @oldtp.TOKEN_PRIVILEGES, @dwSize)
    CloseHandle_(hToken)
  EndIf
EndProcedure
Process_Debug_Privileges()

Procedure Window_Process(Open)
  If Open = 1 And Window_Process\ID = 0
    
    Window_Process\ID = OpenWindow(#PB_Any, 0, 0, 400, 400, "Select Process", #PB_Window_WindowCentered , WindowID(Window_Main\ID))
    If Window_Process\ID
      If UseGadgetList(WindowID(Window_Process\ID))
        Window_Process\ListIcon = ListIconGadget(#PB_Any, 10, 10, 380, 345, "Name", 200, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
        AddGadgetColumn(Window_Process\ListIcon, 1, "PID", 50)
        
        Window_Process\Button[0] = ButtonGadget(#PB_Any, 200, 365, 90, 25, "Ok")
        Window_Process\Button[1] = ButtonGadget(#PB_Any, 300, 365, 90, 25, "Cancel")
        
        
        Process.PROCESSENTRY32\dwSize = SizeOf(PROCESSENTRY32)
        
        Snapshot = CreateToolhelp32Snapshot_(#TH32CS_SNAPPROCESS, 0)
        If Snapshot
          ProcessFound = Process32First_(Snapshot, Process)
          i = 0
          While ProcessFound
            AddGadgetItem(Window_Process\ListIcon, i, PeekS(@Process\szExeFile))
            SetGadgetItemText(Window_Process\ListIcon, i, Str(Process\th32ProcessID), 1)
            i + 1
            ProcessFound = Process32Next_(Snapshot, Process)
          Wend
          CloseHandle_(Snapshot)
        EndIf
        
      EndIf
    EndIf
  ElseIf Open = 0 And Window_Process\ID
    CloseWindow(Window_Process\ID)
    Window_Process\ID = 0
  EndIf
EndProcedure

Procedure Process_Event(Event, Event_Type)
  
  Select Event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case Window_Process\ListIcon
          If Event_Type = #PB_EventType_LeftDoubleClick
            Name.s = GetGadgetItemText(Window_Process\ListIcon, GetGadgetState(Window_Process\ListIcon), 0)
            PID.s = GetGadgetItemText(Window_Process\ListIcon, GetGadgetState(Window_Process\ListIcon), 1)
            Window_Process(0)
            Object_Add(Name, Name, Data_Source_Create(#Data_Source_Process, PID))
          EndIf
        
        Case Window_Process\Button [0]
          If GetGadgetState(Window_Process\ListIcon) >= 0
            Name.s = GetGadgetItemText(Window_Process\ListIcon, GetGadgetState(Window_Process\ListIcon), 0)
            PID.s = GetGadgetItemText(Window_Process\ListIcon, GetGadgetState(Window_Process\ListIcon), 1)
            Window_Process(0)
            Object_Add(Name, Name, Data_Source_Create(#Data_Source_Process, PID))
          EndIf
          
        Case Window_Process\Button [1]
          Window_Process(0)
        
      EndSelect
  EndSelect
EndProcedure
; IDE Options = PureBasic 4.60 Beta 1 (Windows - x64)
; CursorPosition = 87
; FirstLine = 55
; Folding = -
; EnableXP
; DisableDebugger